#!/usr/bin/python
"""
Konvertuje stary format programu navijeni na novy. Jako vstup bere soubory v adresari 'stare' a zkonvertovane uklada do adresaere 'nove'

Vyzaduje: python, iconv, asi linux

"""
import os

zahlavi = 'zahlavi.txt'
zapati = 'zapati.txt'
desetinna_cisla = 'desetinna.txt' #obsahuje radky ktere byly zjisteny vygrepovanim podle noveho vzoroveho programu, funkcni
                                  #pravdepodobne pouze pro 1 typ civek pro navijeni (2. pol/ 4. pol/ ...)
                                  # $cat n.txt | grep '%.1'


def zahlaviZapati(soubor):
  """Vraci zahlavi nebo zapati jako seznam"""
  seznam = []
  fr = open(soubor, 'r')
  data = fr.readlines()
  fr.close()
  for i in data:
    seznam.append(i)
  return seznam

def desetinna():
  """Vraci seznam s cisly radku/promennych obsahujici desetinna cisla"""
  seznam = []
  fr = open(desetinna_cisla, 'r')
  data = fr.readlines()
  fr.close()
  for i in data:
    seznam.append(int(i.split(']')[0][1:]))  
  return seznam

def prevod():
  for jmeno_souboru in os.listdir('stare'): #pro vsechny soubory ve slozce 'stare'
    novy=[]
    fstary = open(os.path.join('stare', jmeno_souboru), 'r') #otevri soubor
    obsahsouboru = fstary.readlines() #nacti obsah souboru
    fstary.close() #a zavri
    print jmeno_souboru,
    for i in obsahsouboru: #pro kazdou radku v obsahu souboru
      data = [int(s) for s in i.split() if s.isdigit()] #vytvor seznam 'data' z cisel v kazdem radku
      if len(data) == 2 and type(data[0]) is int and type(data[1]) is int: #zkontroluj jestli jsou tam jen 2 cisla
        if data[0] in desetinna(): #jesli je prvni cislo desetinne podle vzoru souboru desetinna.txt
          novy.append('['+str(data[0]).zfill(4)+'] ['+str('%10.1f' % data[1]).replace('.', ',')+'][%.1fd][0,10]\r\n')
        else:
          novy.append('['+str(data[0]).zfill(4)+'] ['+'%10d' % data[1]+'][%.0fd][1,00]\r\n')
    fnovy = open(os.path.join('tmp', jmeno_souboru), 'w') #vytvor novy soubor ve slozce 'tmp'
    for i in zahlaviZapati(zahlavi): #zapis zahlavi
      fnovy.write(i)
    for i in novy: #zapis obsah ze seznamu 'novy'
      fnovy.write(i)
    for i in zahlaviZapati(zapati): #zapis zapati
      fnovy.write(i)
    fnovy.close() #zavri novy soubor
    CMD_ICONV = 'iconv -t UTF-16 -f UTF-8 "%s" -o "%s"' % (os.path.join('tmp', jmeno_souboru), os.path.join('nove', jmeno_souboru))
    #os.system('iconv -f UTF-8 -t UTF16 "%s" -o "%s"'% (jmeno, '../nove/' + jmeno))
    os.system(CMD_ICONV) #snaha o prekodovani souboru a ulozeni ve slozce 'nove'
    print "...hotovo"
  

#[int(s) for s in data[1002].split() if s.isdigit()]
#vytvyreni seznamu dvou cisel
#format noveho pro cele cislo [1049] [      1049][%.0fd][1,00]
#format noveho pro desetinne cislo [0997] [       0,0][%.1fd][0,10]

#for i in stary:
#  data = [int(s) for s in i.split() if s.isdigit()]
#  if len(data) == 2 and type(data[0]) is int and type(data[1]) is int:
#    if data[0] in desetinna:
#      #print '[%04d] [%10.1f][\%.1fd][0,10]' % (data[0], data[1])
#      novy.append('['+str(data[0]).zfill(4)+'] ['+str('%10.1f' % data[1]).replace('.', ',')+'][%.1fd][0,10]\r\n')
#      
#    else:
#      novy.append('['+str(data[0]).zfill(4)+'] ['+'%10d' % data[1]+'][%.0fd][1,00]\r\n')

if __name__ == '__main__':
  prevod()
